; NSIS Script For mpiBLAST
;(c)2k4 Aaron Darling
;

;--------------------------------
;Include Modern UI
  !include "MUI.nsh"
;--------------------------------
;General


  Name "mpiBLAST-1.4.0"

  ;Do A CRC Check
  CRCCheck On

!define M_VERSION "1.4.0"
!define MPIBLAST_DIR "C:\Development\mpiblast"

  ;Output File Name
  OutFile "mpiBLAST-${M_VERSION}.exe"

  ;The Default Installation Directory
  InstallDir "$PROGRAMFILES\mpiBLAST"
  
  ;Get installation folder from registry if available
  InstallDirRegKey HKCU "Software\mpiBLAST" ""

;--------------------------------
;Interface Settings

  !define MUI_ABORTWARNING

;--------------------------------
;Pages

  !insertmacro MUI_PAGE_LICENSE "c:\development\mpiBLAST\LICENSE"
  !insertmacro MUI_PAGE_COMPONENTS
  !insertmacro MUI_PAGE_DIRECTORY
  !insertmacro MUI_PAGE_INSTFILES
  
  !insertmacro MUI_UNPAGE_CONFIRM
  !insertmacro MUI_UNPAGE_INSTFILES
  
;--------------------------------
;Languages
 
  !insertmacro MUI_LANGUAGE "English"

;--------------------------------
;Installer Sections

Section "mpiBLAST executables" SecMpiBLAST

  ;Install Files
  SetOutPath $INSTDIR
  SetCompress Auto
  SetOverwrite IfNewer

  ; Top level directory files
  File "${MPIBLAST_DIR}\AUTHORS"
  File "${MPIBLAST_DIR}\blast.cgi"
  File "${MPIBLAST_DIR}\ChangeLog"
  File "${MPIBLAST_DIR}\COPYING"
  File "${MPIBLAST_DIR}\LICENSE"
  File "${MPIBLAST_DIR}\mpiBLAST_docs.pdf"
  File "${MPIBLAST_DIR}\msvc_projects\Release\mpiblast.exe"
  File "${MPIBLAST_DIR}\msvc_projects\Release\mpiblast_cleanup.exe"
  File "${MPIBLAST_DIR}\msvc_projects\Release\mpiformatdb.exe"
  File "${MPIBLAST_DIR}\NEWS"
  File "${MPIBLAST_DIR}\README"
  File "${MPIBLAST_DIR}\TODO"
  File "${MPIBLAST_DIR}\ech_10k.fas"
  File "${MPIBLAST_DIR}\WWWBlastWrap.pl"
  
  ;Store installation folder
  WriteRegStr HKCU "Software\mpiBLAST" "" $INSTDIR

SectionEnd

Section "mpiBLAST source code" SecSource

  SetOutPath "$INSTDIR"
  File "${MPIBLAST_DIR}\configure.in"
  File "${MPIBLAST_DIR}\INSTALL"
  File "${MPIBLAST_DIR}\Makefile.am"
  File "${MPIBLAST_DIR}\mpiblast.nsi"
  File "${MPIBLAST_DIR}\ncbi_Oct2004_evalue.patch"
  File "${MPIBLAST_DIR}\ncbi_Jun2005_evalue.patch"
  File "${MPIBLAST_DIR}\mpiblast.dox"
  File "${MPIBLAST_DIR}\test.pl"


  SetOutPath "$INSTDIR\src"
  File "${MPIBLAST_DIR}\src\blastjob.cpp"
  File "${MPIBLAST_DIR}\src\blastjob.hpp"
  File "${MPIBLAST_DIR}\src\blast_hooks.c"
  File "${MPIBLAST_DIR}\src\blast_hooks.h"
  File "${MPIBLAST_DIR}\src\distributed_bioseq.c"
  File "${MPIBLAST_DIR}\src\distributed_bioseq.h"
  File "${MPIBLAST_DIR}\src\file_util.cpp"
  File "${MPIBLAST_DIR}\src\file_util.hpp"
  File "${MPIBLAST_DIR}\src\formatdb_hooks.h"
  File "${MPIBLAST_DIR}\src\fragment_list.cpp"
  File "${MPIBLAST_DIR}\src\fragment_list.hpp"
  File "${MPIBLAST_DIR}\src\getopt.c"
  File "${MPIBLAST_DIR}\src\getopt.h"
  File "${MPIBLAST_DIR}\src\getopt1.c"
  File "${MPIBLAST_DIR}\src\Makefile.am"
  File "${MPIBLAST_DIR}\src\mpi_util.c"
  File "${MPIBLAST_DIR}\src\mpi_util.h"
  File "${MPIBLAST_DIR}\src\mpiblast.cpp"
  File "${MPIBLAST_DIR}\src\mpiblast.hpp"
  File "${MPIBLAST_DIR}\src\mpiblast_config.cpp"
  File "${MPIBLAST_DIR}\src\mpiblast_config.hpp"
  File "${MPIBLAST_DIR}\src\mpiblast_types.h"
  File "${MPIBLAST_DIR}\src\mpiblast_util.cpp"
  File "${MPIBLAST_DIR}\src\mpiblast_util.hpp"
  File "${MPIBLAST_DIR}\src\mpiformatdb.cpp"
  File "${MPIBLAST_DIR}\src\mpiblast_formatdb.c"
  File "${MPIBLAST_DIR}\src\test_script.pl"

  SetOutPath "$INSTDIR\msvc_projects"
  File "${MPIBLAST_DIR}\msvc_projects\mpiblast.sln"
  File "${MPIBLAST_DIR}\msvc_projects\mpiblast.vcproj"
  File "${MPIBLAST_DIR}\msvc_projects\mpiblast_cleanup.vcproj"
  File "${MPIBLAST_DIR}\msvc_projects\mpiformatdb.vcproj"
SectionEnd

Section "Uninstaller"
  ; Write the uninstall keys for Windows
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\mpiBLAST" "DisplayName" "mpiBLAST ${M_VERSION}"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\mpiBLAST" "UninstallString" "$INSTDIR\Uninstall.exe"
WriteUninstaller "Uninstall.exe"
SectionEnd

;--------------------------------
;Descriptions

  ;Language strings
  LangString DESC_SecMpiBLAST ${LANG_ENGLISH} "Install the mpiBLAST binary executables."
  LangString DESC_SecSource ${LANG_ENGLISH} "Install the mpiBLAST source code."

  ;Assign language strings to sections
  !insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
    !insertmacro MUI_DESCRIPTION_TEXT ${SecMpiBLAST} $(DESC_SecMpiBLAST)
    !insertmacro MUI_DESCRIPTION_TEXT ${SecSource} $(DESC_SecSource)
  !insertmacro MUI_FUNCTION_DESCRIPTION_END

;--------------------------------
;Uninstaller Section

Section "Uninstall"

  ;Delete Files
  Delete /REBOOTOK "$INSTDIR\AUTHORS"
  Delete /REBOOTOK "$INSTDIR\blast.cgi"
  Delete /REBOOTOK "$INSTDIR\ChangeLog"
  Delete /REBOOTOK "$INSTDIR\COPYING"
  Delete /REBOOTOK "$INSTDIR\LICENSE"
  Delete /REBOOTOK "$INSTDIR\mpiblast.conf"
  Delete /REBOOTOK "$INSTDIR\mpiblast.exe"
  Delete /REBOOTOK "$INSTDIR\mpiblast_cleanup.exe"
  Delete /REBOOTOK "$INSTDIR\mpiformatdb.exe"
  Delete /REBOOTOK "$INSTDIR\NEWS"
  Delete /REBOOTOK "$INSTDIR\mpiBLAST_docs.pdf"
  Delete /REBOOTOK "$INSTDIR\README"
  Delete /REBOOTOK "$INSTDIR\TODO"
  Delete /REBOOTOK "$INSTDIR\ech_10k.fas"
  Delete /REBOOTOK "$INSTDIR\WWWBlastWrap.pl"

  Delete /REBOOTOK "$INSTDIR\configure.in"
  Delete /REBOOTOK "$INSTDIR\INSTALL"
  Delete /REBOOTOK "$INSTDIR\Makefile.am"
  Delete /REBOOTOK "$INSTDIR\mpiblast.nsi"
  Delete /REBOOTOK "$INSTDIR\mpiblast.dox"
  Delete /REBOOTOK "$INSTDIR\test.pl"

  Delete /REBOOTOK "$INSTDIR\ncbi_Oct2004_evalue.patch"
  Delete /REBOOTOK "$INSTDIR\ncbi_Jun2005_evalue.patch"

  Delete /REBOOTOK "$INSTDIR\src\blastjob.cpp"
  Delete /REBOOTOK "$INSTDIR\src\blastjob.hpp"
  Delete /REBOOTOK "$INSTDIR\src\blast_hooks.c"
  Delete /REBOOTOK "$INSTDIR\src\blast_hooks.h"
  Delete /REBOOTOK "$INSTDIR\src\distributed_bioseq.c"
  Delete /REBOOTOK "$INSTDIR\src\distributed_bioseq.h"
  Delete /REBOOTOK "$INSTDIR\src\file_util.cpp"
  Delete /REBOOTOK "$INSTDIR\src\file_util.hpp"
  Delete /REBOOTOK "$INSTDIR\src\formatdb_hooks.h"
  Delete /REBOOTOK "$INSTDIR\src\fragment_list.cpp"
  Delete /REBOOTOK "$INSTDIR\src\fragment_list.hpp"
  Delete /REBOOTOK "$INSTDIR\src\getopt.c"
  Delete /REBOOTOK "$INSTDIR\src\getopt.h"
  Delete /REBOOTOK "$INSTDIR\src\getopt1.c"
  Delete /REBOOTOK "$INSTDIR\src\Makefile.am"
  Delete /REBOOTOK "$INSTDIR\src\mpi_util.c"
  Delete /REBOOTOK "$INSTDIR\src\mpi_util.h"
  Delete /REBOOTOK "$INSTDIR\src\mpiblast.cpp"
  Delete /REBOOTOK "$INSTDIR\src\mpiblast.hpp"
  Delete /REBOOTOK "$INSTDIR\src\mpiblast_config.cpp"
  Delete /REBOOTOK "$INSTDIR\src\mpiblast_config.hpp"
  Delete /REBOOTOK "$INSTDIR\src\mpiblast_types.h"
  Delete /REBOOTOK "$INSTDIR\src\mpiblast_util.cpp"
  Delete /REBOOTOK "$INSTDIR\src\mpiblast_util.hpp"
  Delete /REBOOTOK "$INSTDIR\src\mpiformatdb.cpp"
  Delete /REBOOTOK "$INSTDIR\src\mpiblast_formatdb.c"
  Delete /REBOOTOK "$INSTDIR\src\test_script.pl"

  Delete /REBOOTOK "$INSTDIR\msvc_projects\mpiblast.sln"
  Delete /REBOOTOK "$INSTDIR\msvc_projects\mpiblast.vcproj"
  Delete /REBOOTOK "$INSTDIR\msvc_projects\mpiblast_cleanup.vcproj"
  Delete /REBOOTOK "$INSTDIR\msvc_projects\mpiformatdb.vcproj"

  RMDir "$INSTDIR\msvc_projects"
  RMDir "$INSTDIR\src"
  RMDir "$INSTDIR"

  ;Delete Uninstaller And Unistall Registry Entries
  Delete "$INSTDIR\Uninstall.exe"
  DeleteRegKey HKEY_LOCAL_MACHINE "SOFTWARE\mpiBLAST"
  DeleteRegKey HKEY_LOCAL_MACHINE "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\mpiBLAST"
  RMDir "$INSTDIR"

  DeleteRegKey /ifempty HKCU "Software\mpiBLAST"

SectionEnd

